<template>
  <div id="backdrop" @click.self="closeModal">
    <div class="container-fluid h-100 m-0" @click.self="closeModal">
      <div class="row mt-5" @click.self="closeModal">
        <div class="col-md-4" @click.self="closeModal"></div>
        <div class="col-md-4 bg-light rounded">
          <div class="row mt-4">
            <div class="col">
              <h2>Associer un payement</h2>
            </div>
          </div>
          <div class="row">
            <div class="col">
              <hr />
            </div>
          </div>
          <div class="row">
            <div class="col">
              <h5>Informations Payment</h5>
            </div>
          </div>
          <div class="row text-start">
            <div class="col">
              <span class="d-inline"
                ><p class="d-inline fw-bolder me-2">Prénom et Nom:</p>
                <p class="d-inline">
                  {{ payment.last_name }} {{ payment.first_name }}
                </p></span
              >
            </div>
          </div>
          <div class="row text-start">
            <div class="col">
              <span class="d-inline"
                ><p class="d-inline fw-bolder me-2">Montant:</p>
                <p class="d-inline">{{ payment.paid }}</p></span
              >
            </div>
          </div>
          <div class="row text-start">
            <div class="col">
              <span class="d-inline"
                ><p class="d-inline fw-bolder me-2">Categorie:</p>
                <p class="d-inline">{{ payment.category }}</p></span
              >
            </div>
          </div>
          <hr />
          <form
            v-if="!payment.athlete"
            @submit.prevent="associateAthletePayment"
          >
            <div class="row">
              <div class="col">
                <h5>Associé Athlete</h5>
              </div>
            </div>
            <div class="row text-start">
              <div class="col">
                <label for="" class="text-start fw-bolder"></label>
                <select
                  class="form-select"
                  aria-label="Default select example"
                  v-model="selectedAthlete"
                >
                  <option value="" disabled selected hidden></option>
                  <option
                    v-for="athlete in athletes"
                    :key="athlete.id"
                    :value="athlete.id"
                  >
                    {{ athlete.first_name }} {{ athlete.last_name }} {{athlete.id}}
                  </option>
                </select>
              </div>
            </div>
            <div class="row m-3">
              <div class="col">
                <button class="btn btn-primary" type="submit">Associer</button>
              </div>
            </div>
          </form>
          <div v-else>
            <div class="row">
              <div class="col">
                <h5>Informations Athlete</h5>
              </div>
            </div>
            <div class="row text-start">
              <div class="col">
                <span class="d-inline"
                  ><p class="d-inline fw-bolder me-2">Prénom et Nom:</p>
                  <p class="d-inline">
                    {{ athlete.first_name }} {{ athlete.last_name }}
                  </p></span
                >
              </div>
            </div>
            <div class="row text-start">
              <div class="col">
                <span class="d-inline"
                  ><p class="d-inline fw-bolder me-2">Categorie:</p>
                  <p class="d-inline">
                    {{ athlete.team.category.label }}
                  </p></span
                >
              </div>
            </div>
            <div class="row text-start">
              <div class="col">
                <span class="d-inline"
                  ><p class="d-inline fw-bolder me-2">Prix normal:</p>
                  <p class="d-inline">
                    {{ athlete.team.category.price }}
                  </p></span
                >
              </div>
            </div>
            <div class="row text-start">
              <div class="col">
                <span class="d-inline"
                  ><p class="d-inline fw-bolder me-2">Prix VA:</p>
                  <p class="d-inline">
                    {{ athlete.team.category.va_price }}
                  </p></span
                >
              </div>
            </div>
            <div class="row text-start">
              <div class="col">
                <div v-if="payment.athlete">
                  <label for="" class="fw-bold me-2">Statut: </label>
                  <span
                    v-if="athletePayment.status === 1"
                    class="badge rounded-pill bg-success"
                  >
                    Validé
                  </span>
                  <span
                    v-else-if="athletePayment.status === 2"
                    class="badge rounded-pill bg-danger"
                  >
                    Rejeté
                  </span>
                  <span v-else class="badge rounded-pill bg-primary">
                    Associé
                  </span>
                </div>
              </div>
            </div>
            <div class="row text-start">
              <div class="col text-center mb-3">
                <button class="btn btn-success me-2" @click="validatePayment">
                  Valider
                </button>
                <button class="btn btn-danger" @click="rejectPayment">
                  Rejeter
                </button>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-4" @click.self="closeModal"></div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import axios from "axios";

export interface Athlete {
  id: number;
  first_name: string;
  last_name: string;
}

export default defineComponent({
  props: {
    paymentId: Number,
  },
  data() {
    return {
      athletes: [] as Athlete[],
      payment: {
        id: 0,
        first_name: "",
        last_name: "",
        category: "",
        paid: 0,
        athlete: [],
      },
      athlete: {
        id: null,
        first_name: null,
        last_name: null,
        birthdate: null,
        email: null,
        phone: null,
        team: {
          name: null,
          category: {
            label: null,
            price: null,
            va_price: null,
          },
        },
        certificate: {
          id: null,
          status: null,
        },
      },
      athletePayment: {
        id: null,
        status: null,
        athlete: {
          id: null,
        },
      },
      selectedAthlete: null,
    };
  },
  methods: {
    closeModal() {
      this.$emit("closeModal");
    },
    loadAthletes() {
      axios.get("athletes/").then((response) => {
        this.athletes = response.data["results"];
        console.log(this.athletes);
      });
    },
    loadAthlete() {
      if (this.athletePayment.id && this.athletePayment.athlete) {
        axios
          .get("athletes/" + this.athletePayment.athlete.id)
          .then((response) => (this.athlete = response.data));
      }
    },
    loadPayment() {
      axios.get("payments/" + this.paymentId).then((response) => {
        this.payment = response.data;
        console.log(response.data["athlete"]);
        if (response.data["athlete"]) {
          axios.get("athlete_payments/"+String(response.data["athlete"]["id"])).then((response => {
            this.athletePayment = response.data;
           this.loadAthlete();
          }))
          
         
        }
      });
    },
    associateAthletePayment() {
      console.log("Associate to athlete");
      console.log(this.selectedAthlete)
      axios
        .post("athlete_payments/", {
          payment_id: this.paymentId,
          athlete_id: this.selectedAthlete,
        })
        .then((response) => {
          console.log(response);
          this.loadPayment();
        });
    },
    validatePayment() {
      console.log("Validating payment...");
      axios
        .post("athlete_payments/" + this.athletePayment.id + "/validate/")
        .then(() => {
          this.loadPayment();
        });
    },
    rejectPayment() {
      console.log("Rejecting Payment...");
      axios
        .post("athlete_payments/" + this.athletePayment.id + "/reject/")
        .then(() => {
          this.loadPayment();
        });
    },
  },
  watch: {
    paymentId() {
      console.log(this.paymentId);
      this.loadPayment();
      this.loadAthletes();
    },
  },
});
</script>

<style scoped>
#backdrop {
  top: 0;
  position: fixed;
  background: rgba(0, 0, 0, 0.5);
  width: 100%;
  height: 100%;
  z-index: 10001;
  margin: 0;
}
</style>
